﻿:Class AddressBook
    :Include #.Tools
    :Field Private keys
    :Field Private values 
⍝   :Field Private _contacts 
    :Field Public Source←''
    
    ∇ make
      :Access Public
      :Implements Constructor
   ⍝   keys←0⍴⊂'' ''
      _contacts←0⍴⎕NEW #.Contact
    ∇
    ∇ new1 filepath;⎕USING;doc
    ⍝ construct from XML document at filepath
      :Access Public
      :Implements Constructor
    ⍝  initialise
      _contacts←0⍴⎕NEW #.Contact
      ⎕USING←'System.Xml,System.XML.dll'
      doc←⎕NEW XmlDocument
      doc.Load⊂filepath
    ⍝  (SerialMap ⎕THIS)#.Serialise.XmlCopyContents⌷doc.LastChild.ChildNodes
      ⎕THIS∘{⍵.LocalName≡'contact':⍺._contacts,←⎕NEW #.Contact ⍵
          ''
      }¨⌷doc.LastChild.ChildNodes
      Source←filepath
    ∇
    
    :Property Keyed Default Contacts
    :Access Public Instance
        ∇ v←get arg;k;surnames
          k←arg.Indexers
          k←fixkeys k
         
          :If ∨/' '∊¨k
             ⍝ v←(_contacts,0)[keys⍳k]
              v←(_contacts,0)[_contacts.FullName⍳k]
          :Else
              surnames←_contacts.FamilyName
              v←(_contacts,0)[surnames⍳k]
          :EndIf
        ∇
    :EndProperty
    
    :Property Simple ContactList
    :access Public
        ∇ v←get;surnames
          surnames←_contacts.FamilyName
          v←_contacts[⍋↑surnames]
        ∇
    :endProperty
    
    
    
    ∇ c←AddContact contact
      :Access Public
      c←⎕NEW #.Contact contact
    ⍝  keys,←⊂c.FullName
      _contacts,←c
    ∇
    
    ∇ k←fixkeys k
      k←(2≠≡¨k){,(⊂⍣⍺)⍵}¨k
      k←⊃(∘.{⊃,/⊂¨⍺ ⍵})/k
    ∇
    
    ∇ Save filepath;clmts;∆;hdr;xml;CR;addressbook
      :Access Public
      CR←⎕TC[3]
      ∆←⊃,/(⌷_contacts).XML
      hdr←'<?xml version="1.0" encoding="iso-8859-1" standalone="yes"?>'
      addressbook←CR join'addressbook'tag ∆                                 ⍝ close
      xml←CR join hdr addressbook
      xml writeAsFile filepath                                              ⍝ put file
    ∇
    
    
:EndClass